package com.dougmccune.controls
{
	import qs.controls.Fisheye;
	import com.dougmccune.effects.YoyoMove;
	import mx.core.UIComponent;
	import mx.effects.easing.Cubic;
	import flash.utils.Dictionary;
	import flash.display.BlendMode;
	import flash.events.MouseEvent;

	public class BouncingFisheye extends Fisheye
	{
		private var bounceArray:Dictionary = new Dictionary();
	
		public var bounceDistance:Number = 50;
		
		override public function set selectedIndex(value:int):void {
			super.selectedIndex = value;
			
			var item:UIComponent = renderers[value] as UIComponent;
			var minorAlignValue:String = getStyle(minor.align);

			if(item is BouncingBurningTile) {
				var toX:Number = 0;
				var toY:Number = 0;
				
				if(this.direction == "vertical") {
					switch(minorAlignValue)
					{
						case "center":
						case "justified":
						case "right":
							toX = -bounceDistance;
							break;
						case "left":
							toX = bounceDistance;
							break;
					}
				}
				else {
					switch(minorAlignValue)
					{
						case "center":
						case "justified":
						case "bottom":
							toY = -bounceDistance;
							break;
						case "top":
							toY = bounceDistance;
							break;
					}
				}
				BouncingBurningTile(item).bounceImage(-1, toX, toY, 3);
				(item as BouncingBurningTile).burning = true;
			}
			
			
			for(var i:int=0; i<renderers.length; i++) {
				if(i==value) continue;
				
				item = renderers[i] as BouncingBurningTile;
				BouncingBurningTile(item).burning = false
			}
			
		}
		
		
		
		public function stopBouncingAt(index:int):void {
			var item:UIComponent = renderers[index] as UIComponent;
			
			if(item is BouncingBurningTile) {
				(item as BouncingBurningTile).stopBouncing();	
			}
		}
		
	}
}