package com.dougmccune.controls
{
	import qs.controls.BitmapTile;
	import flexlib.controls.Fire;
	import flash.display.BlendMode;
	import mx.effects.Tween;

	public class BurningBitmapTile extends BitmapTile
	{
		private var fire:Fire;
		private var _burning:Boolean = false;
		private var _childrenCreated:Boolean = false;
		
		
		public function BurningBitmapTile()
		{
			super();
		}
		
		override protected function createChildren():void {
			super.createChildren();
			
			_childrenCreated = true;
			
			if(_burning) {
				createFire();
			}
		} 
		
		
		
		[Bindable]
		public function set burning(value:Boolean):void {
			_burning = value;
			
			if(_childrenCreated) {
				removeFire();
			
				if(_burning) {
					createFire();
				}
			}
		}
		
		private function createFire():void {
			fire = new Fire();

			fire.blendMode = BlendMode.SCREEN;
			
			fire.alpha = 0;
			fire.ySpeed = 3;
			fire.wFactor = 4;
			
			fire.color = data.color;
			
			var tween:Tween = new Tween(this, 0, 1, 1000);
			
			addChildAt(fire, 0);
			
			fire.alpha = 0;
			invalidateDisplayList();
		}
		
		public function onTweenUpdate(value:Object):void {
			if(fire) {
				fire.alpha = Number(value);
			}
		}
		
		public function onTweenEnd(value:Object):void {
			if(fire) {
				fire.alpha = Number(value);
			}
		}
		
		private function removeFire():void {
			if(fire && fire.parent == this) {
				fire.stopBurning();
				removeChild(fire);
			}	
		}
		
		public function get burning():Boolean {
			return _burning;
		}
		
		override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth, unscaledHeight);
			
			if(_burning) {
				fire.setActualSize(unscaledWidth, unscaledHeight + 70);
				fire.move(-10,-130);
			}
		}
		
		
	}
}