package com.dougmccune.effects
{
	import mx.effects.IEffectInstance;
	import mx.effects.Move;
	import mx.events.EffectEvent;


	
	public class YoyoMove extends Move
	{
		private var reversed:Boolean = false;
		private var ending:Boolean = false;
		
		public var yoyoCount:Number = 0;

		
		private var _currentYoyoCount:Number = 0;
		
		
		public function YoyoMove(target:Object = null)
		{
			super(target);
		}
			
		public function get currentYoyoCount():Number {
			return _currentYoyoCount;
		}

	 	override public function play(targets:Array=null, playReversedFromEnd:Boolean=false):Array
	 	{
	 		if(_currentYoyoCount > 0) {
	 			_currentYoyoCount = 0;
	 			return null;
	 		}
	 		
	 		_currentYoyoCount++;
		 		
		 	reversed = playReversedFromEnd;
		 		
		 	return super.play(targets, playReversedFromEnd);
	 	}
	 	
	 	private function playAgain(targets:Array=null, playReversedFromEnd:Boolean=false):Array {
	 		_currentYoyoCount++;
	 		
		 	reversed = playReversedFromEnd;
		 		
		 	return super.play(targets, playReversedFromEnd);
	 	}
	 	
	 	override public function end(effectInstance:IEffectInstance=null):void {
	 		ending = true;
	 	}
		
		override protected function effectEndHandler(event:EffectEvent):void 
    	{
			var effectInstance:IEffectInstance = event.effectInstance;
			effectInstance.repeatCount

			if( 
				(!ending && (_currentYoyoCount <= yoyoCount + 1 || yoyoCount == -1)) 
				|| !reversed ) {
				
				this.playAgain(this.targets, !reversed);
			}
			else {
				ending = false;
				_currentYoyoCount = 0;
				
				super.effectEndHandler(event);
				
				super.end(event.effectInstance);
			}
		}
	}
}