/*
    FXCToolTipBorder
    
    HTML supported tooltip, I just love it when code comes together
    Now with the sticky tooltip feature;
    
    version 0.1
    -	Background is scaling to match htmlText;
    -	Tooltip sticks to mouse;
    
    TODO:
    - For some reason it's ignoring the style in the HTML-text
    
    Created by Maikel Sibbald
    info@flexcoders.nl
    http://labs.flexcoders.nl
    
    Free to use.... just give me some credit
*/
package nl.fxc.skins{
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.events.TimerEvent;
    import flash.text.TextField;
    
    import mx.controls.ToolTip;
    import mx.core.Application;
    import mx.core.UITextField;
    import mx.effects.Fade;
    import mx.events.EffectEvent;
    import mx.managers.ToolTipManager;
    import mx.skins.halo.ToolTipBorder;
    import mx.skins.ProgrammaticSkin;
    import flash.display.Graphics;
    import flash.filters.DropShadowFilter;
    import flash.filters.GlowFilter;
    import mx.managers.ISystemManager;

    public class FXCToolTip extends ToolTipBorder{
        
       	public function FXCToolTip():void{
        	super();
        	//if you want your regular tooltip with HTML support, comment the following out
        	this.makeSticky();
        }
        
        private function makeSticky():void{
        	var fadeFX:Fade = new Fade();
			fadeFX.alphaFrom = 1;
			fadeFX.alphaTo = 1;
			fadeFX.addEventListener(EffectEvent.EFFECT_START , function():void{
				parent.x = Application.application.mouseX + 10;
        		parent.y = Application.application.mouseY + 10;
        		
			});
			
			ToolTipManager.showEffect = fadeFX;
        	this.addEventListener(Event.ENTER_FRAME, function():void{
        		if(parent != null){
        			parent.x = Application.application.mouseX + 10;
        			parent.y = Application.application.mouseY + 10;
        			
        		}
        		
        		
        	});
        }
        
      
        
        override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void{
            this.makeSticky();
            
            
            
            var toolTip:ToolTip = (this.parent as ToolTip);
            var textField:UITextField = toolTip.getChildAt(1) as UITextField;
            textField.htmlText = textField.text;
            
            var calHeight:Number = textField.height;
            calHeight += textField.y*2;
            calHeight += textField.getStyle("paddingTop");
            calHeight += textField.getStyle("paddingBottom");
            
            var calWidth:Number = textField.textWidth;
            calWidth += textField.x*2;
            calWidth += textField.getStyle("paddingLeft");
            calWidth += textField.getStyle("paddingRight");
            
            super.updateDisplayList(unscaledWidth, calHeight);
            
            
            var borderStyle:String = getStyle("borderStyle");
			var backgroundColor:uint = getStyle("backgroundColor");
			var backgroundAlpha:Number= getStyle("backgroundAlpha");
			var borderColor:uint = getStyle("borderColor");
			var cornerRadius:Number = getStyle("cornerRadius");
			var shadowColor:uint = getStyle("shadowColor");
			var shadowAlpha:Number = 0.1;
		
            var g:Graphics = graphics;
			g.clear();
			filters = [];
			
			var w:Number = unscaledWidth;
			var h:Number = unscaledHeight;
			
			
            drawRoundRect(
				11, 0, w - 11, h - 2, 3,
				borderColor, backgroundAlpha); 

			// left pointer 
			g.beginFill(borderColor, backgroundAlpha);
			g.moveTo(11, 7);
			g.lineTo(0, 13);
			g.lineTo(11, 19);
			g.moveTo(11, 7);
			g.endFill();
			
			filters = [ new DropShadowFilter(2, 90, 0, 0.4), 
				new GlowFilter(getStyle("themeColor"), 1, 3, 3, 2, 1, false, false) ];
		
			
        }

    }
}